/*****************************************************
*@@VS1011E@䃉Cu 
*  
******************************************************/
#include "VS1011.h"
#include <p24FJ64GA002.h>
/************************************
* SPI Read after Write@{֐
************************************/
BYTE WriteSPI(BYTE output){
	MP3_SPI_IF = 0;				// 荞݃tONA
	MP3_SSPBUF = output;		// SPIo
	while(!MP3_SPI_IF);			// ͑҂
	return MP3_SSPBUF;			// ̓f[^߂l
}
/************************************
*  VS1011pR}ho͊֐
************************************/
void Command(BYTE RegAdrs, BYTE UpData, BYTE LowData){
	MP3_XDCS_IO = 1;			// f[^[h
	while(!MP3_DREQ_IO);		// fB[҂
	MP3_XCS_IO = 0;				// R}h[hݒ 
	WriteSPI(0x02);				// ݓw
	WriteSPI(RegAdrs);			// WX^AhXo
	WriteSPI(UpData);			// ʃoCgo
	WriteSPI(LowData);			// ʃoCgo
	MP3_XCS_IO = 1;				// R}h[h
}
/************************************
*  VS1011pR}ho͊֐(mFt)
************************************/
void CmdCheck(BYTE RegAdrs, BYTE UpData, BYTE LowData){
	BYTE b1,b2;

	do{
		MP3_XDCS_IO = 1;		// f[^[h
		while(!MP3_DREQ_IO);	// fB[҂
		MP3_XCS_IO = 0;			// R}h[hݒ 
		WriteSPI(0x02);			// ݓw
		WriteSPI(RegAdrs);		// WX^AhXo
		WriteSPI(UpData);		// ʃoCgo
		WriteSPI(LowData);		// ʃoCgo
		MP3_XCS_IO = 1;			// R}h[h
		while(!MP3_DREQ_IO);	// fB[҂
		MP3_XCS_IO = 0;			// ǂݍ݊mF
		WriteSPI(0x03);			// ǂݍݓ
		WriteSPI(RegAdrs);		// WX^AhXw
		b1 = WriteSPI(0xFF);	// return UpData
		b2 = WriteSPI(0xFF);	// return LowData
		MP3_XCS_IO = 1;	
	}while((b1 != UpData) || (b2 != LowData));
}
/************************************
*  VS1011pf[^o͊֐
************************************/
void SendData(BYTE Data){
	while(!MP3_DREQ_IO);		// fB[҂
	WriteSPI(Data);
}

/***********************************************
*  ʃxݒ֐
*   vRight = E`lp
*   vLeft  = `lp
*@@   @0x00=Max 0dB 0.5dBXebvŉ
************************************************/
void SetVolume(BYTE vRight, BYTE vLeft){
	Command(0x0B, vRight, vLeft);
}

/**********************************************
*  ቹu[Xgݒ萧֐
*    bassF ቹQC@W0dB15dB͈̔
*    gfreq: ቹu[Xggݒ@10HzXebv@0`15͈̔
***********************************************/
void SetBassBoost(BYTE bass, BYTE gfreq)
{
	BYTE temp1 = 0;
	/* ݒ͈͂̐ */
	if(bass > 15)
		bass = 15;
	if(gfreq > 15)
		gfreq = 15;
	/* 8rbgɍ */
	temp1 = gfreq;
	temp1 |= (bass << 4);
	Command(0x02, 0xFF, temp1);		// BASS	
	return;
}
/*********************************************
*	ĐI֐
*
*********************************************/
void PlayEnd(void){
	int i;

	/* Đobt@NÂ2048oCgM@*/
	MP3_XDCS_IO = 0;						// XDCSI
	for(i=0; i<2048; i++)
		SendData(0);						// 0̃f[^AM
	MP3_XDCS_IO = 1;						// XDCSIt
	/*** \tgEFAZbgŊ **/
	Command(0x00, 0x08, 0x24);				// SM_RESETM
	while(!MP3_DREQ_IO);					// R}h҂
}
/********************************************
*  VS1011 ֐
*    VS1011][hASDIeXg[h@ɐݒ
*    VS1011ƐɒʐMłȂƉiv҂ƂȂ
*********************************************/
void VS1011_Init(void){
	unsigned int val;
	/***** VS1011p|[g̏ݒ   ***/
	MP3_XDCS_IO = 1;				// DCSHigh
	MP3_XCS_IO = 1;					// XCSHigh
	MP3_XRESET_IO = 0;				// XRESETLow
	MP3_XRESET_TRIS = 0;			// oTRISL
	MP3_DREQ_TRIS = 1;				// DREQ̓[h
	MP3_XDCS_TRIS = 0;				// XDCSo
	MP3_XCS_TRIS = 0;				// XCSo
	MP3_SDI_TRIS = 1;				// SDI2̓[h
	MP3_SDO_TRIS = 0;				// SDO2o̓[h
	MP3_SCK_TRIS = 0;				// SCK2o̓[h
 	/***** SPI2̏ݒ   ***/
	MP3_SPICON1 = 0x003E;			// 8rbg[h,CKP = 0,CLK=Fosc/4 (4MHz)
									// ŃTv(SMP=0) GbWőM(CKE=1)
	MP3_SPICON2 = 0;				// t[[hȂ
	MP3_SPI_IF = 0;					// 荞݃tONA
	MP3_SPISTATbits.SPIEN = 1;		// SPI2Cl[u
	/* RESETAVS1011X^[g  */
	delay_ms(50);					// 50msec delay
	MP3_XRESET_IO = 1;				// RESET
	/** [hݒ@*/
	CmdCheck(0x00, 0x08, 0x20);		// [hݒ@V[hASDIeXg[h
	/* NbN_uݒ@*/
	val = 12288 / 2 + 0x8000;		// ݒl߂if[^V[gj
	CmdCheck(0x03, (BYTE)(val /256), (BYTE)val);
	delay_ms(10);
}

/********************************************
*  VS1011 geXg[hݒ֐
*    MODESPIeXg[hɐݒ肵ĂKv
*********************************************/
void VS1011_SineTest(void)
{
	/* eXg[hV[PXo */
	while(!MP3_DREQ_IO);
	MP3_XDCS_IO = 0;
 	// Start Sine Test
	WriteSPI(0x53);
	WriteSPI(0xEF);
	WriteSPI(0x6E);
	WriteSPI(0x7D);				// 22.050kHz Out is 5kHz
	WriteSPI(0x00);
	WriteSPI(0x00);
	WriteSPI(0x00);
	WriteSPI(0x00);
	MP3_XDCS_IO = 1;
}
/****************************
* usecPʃfBC֐
****************************/
void delay_us(int usec){
	usec = (int)(CLOCK*usec)/ 10;
	while(usec)	{
		asm("NOP");
		asm("NOP");
		asm("NOP");
		asm("NOP");
		asm("NOP");					
		usec--;
	}
}
/***************************
* msecPʃfBC֐
***************************/
void delay_ms(int msec){
	int i;
	for(i=0; i< msec; i++)
		delay_us(1000);
}


